include:
  - template: SAST.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml
  - template: Code-Quality.gitlab-ci.yml
  - template: Secret-Detection.gitlab-ci.yml

stages:
  - test
  - build

docker-build:
  # Official docker image.
  image: docker:latest
  stage: build
  services:
    - docker:dind
  # on utilise les fonctions de cache de Docker car les runners de Gitlab.com n'ont pas de caches de build par sécurité.
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker pull "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" || true
  script:
    - docker build --pull --cache-from "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2

client-build:
  image: golang:1.14-alpine
  stage: build
  before_script:
    - apk add gtk+3.0-dev cairo-dev glib-dev build-base
  script:
    - GOOS=linux CGO_ENABLED=0 go build -a -tags netgo -ldflags '-w -extldflags "-static"' -o client-linux adminclient/main.go
  artifacts:
    paths:
      - client-linux
